/*
      Edit Server Example V1.02
      (Server Part) in C by Faceless Wonder

      All source code hereforth is  Copyright 2002, 2003 Faceless Wonder
      Email: YetAnotherFacelessWonder@yahoo.co.uk
      Web:   http://areyoufearless.com/

      IMPORTANT NOTES:
      The server source code contains NO hostile code of
      any kind, or any Sockets implementation. This code
      is just to demonstrate the mechanics of appending
      and retrieving appended data to/from the end of a
      executable.

      Some areas of the source code may appear bloated and
      slightly cumbersome to some of the more experienced
      programmers. The code has been written in such a way
      that (hopefully) explains what the code is actually
      doing. I'm well aware that it can easily be optimised
      to reduce the working code size. I've sacrificed code
      size for clarity and understandability.

      CONDITIONS OF USE:
      If you use any of this source code either in full or
      in part, then credit MUST be given to the author. If
      you do not give due credit, then in simplest terms,
      you are a lamer, and jepardise the future release of
      other source codes.

      If you find his source code useful, you can help others
      by telling them about it. This source code may NOT be
      published or hosted without the author's consent.


      This code has been successfully compiled using the following compilers:
           MingW V2.95
           Borland Command Line Compiler V5.5.1
           Microsoft Visual C++ V6.00 Enterprise
*/



#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

/* Macro to define the max path size.                                          */
#define MAX_PATH_SIZE 1024

/* Macro to define the max data size.                                          */
#define MAX_DATA_SIZE 41

/* Standard Windows entry point for the program. */
int main (void)
{
    /* Array to store the filename of the currently running server file.       */
    char szFileName[MAX_PATH_SIZE+1] = "\0";                                                

    /* This is the format of the data we want to read:
            DATA:          password       port     exe name
            SIZE:            (20)         (6)        (15)
                     |------------------||----||-------------| */
                     
    /* Initialise the array to null chars (of size MAX_DATA_SIZE + 1 for a  
       null char) for the data to be read into.                                */
    char szReadData[MAX_DATA_SIZE+1] = "\0";
    
    /* Temporary buffer and position pointer, for use in interpreting the data.*/
    char szTmpBuff[MAX_DATA_SIZE+1] = "\0";
    unsigned int iTmpPos, i;

    /* Declare the file handle. */
    HANDLE fhSource;
    
    /* To record the number of bytes read later on.                            */
    DWORD iBytesRead = 0;

    /* Get the running server file path.                                       */
    GetModuleFileName(GetModuleHandle(NULL), szFileName, MAX_PATH_SIZE);
      
    /* Open the target file for reading from, using Win32 API. */
    fhSource = CreateFile(szFileName,        /* Address of file.                                    */
                          GENERIC_READ,      /* Access attributes, ie allow reads.                  */
                          FILE_SHARE_READ,   /* Share Mode. Allow Read.                             */
                          NULL,              /* Security Descriptor (NULL means default)            */
                          OPEN_EXISTING,	 /* Creation Disposition (open existing file if exists) */
                          0,                 /* Flags and attributes (NONE)                         */
                          0);                /* Template file (NONE)                                */

    /* The file has been opened successfully if the file handle is valid.      */
    if (fhSource != INVALID_HANDLE_VALUE)
    {
        /* Set the pointer to MAX_DATA_SIZE bytes from the end of the file.    */
        SetFilePointer(fhSource, -MAX_DATA_SIZE, NULL, FILE_END);
       
        /* Now read MAX_DATA_SIZE bytes from the end of the file. If the data 
           was NOT successfully appended to the end of the server, then there 
           will be an issue because you will read the program data, since there
           is no appended data to read. Therefore some kind of check to see if
           there is appended data is a good idea. I suggest some kind of key or
           identifier at the beginning or end of the data, which the presence of
           can be checked for once the data has been read.                     */
        ReadFile(fhSource, szReadData, MAX_DATA_SIZE, &iBytesRead, NULL);
       
        /* Now finished with the file, so we must close it now.                */
        CloseHandle(fhSource);
                
        /* If the number of bytes read equals the number of bytes that we
           wanted to read, then the operation was successful.                  */
        if (iBytesRead == MAX_DATA_SIZE)
        {
        
           /* Get the password from the read data without trimming trailing spaces */
           for (i = 0, iTmpPos = 0; i < 20; i++)           
               szTmpBuff[iTmpPos++] = szReadData[i];
           /* Add terminating null character at end of copied string (saves 
              clearing the whole array each time, since null char marks the en
              of the string in the array.                                      */
           szTmpBuff[iTmpPos] = '\0';
           /* Print the data in the temporary buffer.                          */         
           printf("Password: %s\n", szTmpBuff);
           
           
           /* Get the port from the read data...                               */
           for (i = 20, iTmpPos = 0; i < 26; i++)           
               szTmpBuff[iTmpPos++] = szReadData[i];
           /* As above. */
           szTmpBuff[iTmpPos] = '\0';   
           /* Note that the port is actually converted to a long here!         */        
           printf("Port: %d\n", strtol(szTmpBuff, NULL, 10));
           
           
           /* Get the exe name from the read data without trimming trailing spaces */
           for (i = 26, iTmpPos = 0; i < 41; i++)           
               szTmpBuff[iTmpPos++] = szReadData[i];
           /* As above. */
           szTmpBuff[iTmpPos] = '\0';           
           printf("Exename: %s\n", szTmpBuff);
           
           /* Done!                                                            */
           MessageBox(0, "File successfully read from!", "Success!", MB_OK | MB_ICONINFORMATION);
        }
        else
           MessageBox(0, "Error reading from the file!", "Error!", MB_OK | MB_ICONERROR);
    }
    
    /* Error opening the file, so report the error. Doing something such as 
       creating defaults or quitting quietly is probably a good idea in a real
       server. The message box is just to demonstrate that there may be errors 
       opening the file!                                                       */
    else 
    {
        /* Nice little error message box! */
        MessageBox(0, "Error opening file!", "Error!", MB_OK | MB_ICONERROR);
        
        /* Exit with failure error code. */
        return 1;
    }
   


    return 0;
}
