{
      Edit Server Example V1.02
      (Editor Part) in Delphi by Faceless Wonder
      
      All source code hereforth is  Copyright 2002, 2003 Faceless Wonder
      Email: YetAnotherFacelessWonder@yahoo.co.uk
      Web:   http://areyoufearless.com/

      IMPORTANT NOTES:
      The server source code contains NO hostile code of
      any kind, or any Sockets implementation. This code
      is just to demonstrate the mechanics of appending
      and retrieving appended data to/from the end of a
      executable.

      Some areas of the source code may appear bloated and
      slightly cumbersome to some of the more experienced
      programmers. The code has been written in such a way
      that (hopefully) explains what the code is actually
      doing. I'm well aware that it can easily be optimised
      to reduce the working code size. I've sacrificed code
      size for clarity and understandability.

      CONDITIONS OF USE:
      If you use any of this source code either in full or
      in part, then credit MUST be given to the author. If
      you do not give due credit, then in simplest terms,
      you are a lamer, and jepardise the future release of
      other source codes.

      If you find his source code useful, you can help others
      by telling them about it. This source code may NOT be
      published or hosted without the author's consent.


      This code has been successfully compiled using the following compilers:
           Borland Delphi Client/Server Suite Version 3
}

program Editor;

{ Uses Windows.pas }
uses Windows;

    { Constant to define the max path size.                                     }
    const MAX_PATH_SIZE = 1024;

    { Constant to define the max data size.                                     }
    const MAX_DATA_SIZE = 41;

    {### Variable Declarations ###}
    var
    
    { Specify the path of the file to edit in a character array. The path can
      easily be determined dynamically by using a FileOpen dialog, or getting
      the input from the standard input (console), just store the target path
      in a character array such as the one stated below. Remember the extra
      character for the null char when using strings.                           }
      szSourcePath : Array[0..MAX_PATH_SIZE+1] of Char = 'server.exe';

    { Specify the data that we want to save to the server. This can be things
      such as passwords, port numbers, which startup methods to use, etc. i.e.
      this can be ANY data that can be represented as binary data. Binders use
      this technique to attach files to a stub. Remember an extra character for
      the null char when using strings.

                                                  DATA:          password      port     exe name
                                                  SIZE:            (20)        (6)        (15)
                                                          |------------------||----||-------------| }
      szSourceData : Array[0..MAX_DATA_SIZE+1] of Char = 'SecretPassword      6666  netmon32.exe   ';

    { To record the number of bytes written later on.                           }
      iBytesWritten : DWORD = 0;

    { File handle for the file to be opened, initialised to a invalid handle.   }
      fhSource : THandle = INVALID_HANDLE_VALUE;



{ Entry point of the program. }
begin

    { Open the target file for writing to, using Win32 API. }
    fhSource := CreateFile(szSourcePath,      // Address of file (NULL term string)
                           GENERIC_WRITE,     // Access attributes, ie allow writes.
                           FILE_SHARE_READ,   // Share Mode. Allow Read.
                           nil,               // Security Descriptor (nil means default)
                           OPEN_EXISTING,     // Creation Disposition (open existing file if exists)
                           0,                 // Flags and attributes (NONE)
                           0);                // Template file (NONE)

    { The file has been opened successfully if the file handle is valid.        }
    if (fhSource <> INVALID_HANDLE_VALUE) then
    begin
        { We want to append data at the end of the file, so position the
          file pointer at the end of the file. (NOTE: If you wanted to UPDATE
          the settings for a file, rather than APPEND the data at the end, you
          would need to set the 0 below, to [0-MAX_DATA_SIZE], since the start
          of the data would be MAX_DATA_SIZE bytes from the end of the file.)   }
        SetFilePointer(fhSource, 0, nil, FILE_END);
       
        { Now write the data we've got in szSourceData to the file, for
          MAX_DATA_SIZE bytes (since there is a null char too, but we don't
          want to write the null char since we don't need it). Pass the address
          of iBytesWritten so that we can record how many bytes were actually
          written to the file.                                                  }
        WriteFile(fhSource, szSourceData, MAX_DATA_SIZE, iBytesWritten, nil);
       
        { Now finished with the file, so we must close it now.                  }
        CloseHandle(fhSource);
                
        { If the number of bytes written equals the number of bytes that we
          wanted to write, then the operation was successful. So display a
          message indicating success or error.                                  }
        if (iBytesWritten = MAX_DATA_SIZE) then
           MessageBox(0, 'File successfully written to!', 'Success!', MB_OK or MB_ICONINFORMATION)
        else
           MessageBox(0, 'Error writing to the file!', 'Error!', MB_OK or MB_ICONERROR);
    end
    
    { Error opening the file, so report the error.                              }
    else
        { Nice little error message box!                                        }
        MessageBox(0, 'Error opening file!', 'Error!', MB_OK or MB_ICONERROR);

end.
