{
      Edit Server Example V1.02
      (Server Part) in Delphi by Faceless Wonder

      All source code hereforth is  Copyright 2002, 2003 Faceless Wonder
      Email: YetAnotherFacelessWonder@yahoo.co.uk
      Web:   http://areyoufearless.com/

      IMPORTANT NOTES:
      The server source code contains NO hostile code of
      any kind, or any Sockets implementation. This code
      is just to demonstrate the mechanics of appending
      and retrieving appended data to/from the end of a
      executable.

      Some areas of the source code may appear bloated and
      slightly cumbersome to some of the more experienced
      programmers. The code has been written in such a way
      that (hopefully) explains what the code is actually
      doing. I'm well aware that it can easily be optimised
      to reduce the working code size. I've sacrificed code
      size for clarity and understandability.

      CONDITIONS OF USE:
      If you use any of this source code either in full or
      in part, then credit MUST be given to the author. If
      you do not give due credit, then in simplest terms,
      you are a lamer, and jepardise the future release of
      other source codes.

      If you find his source code useful, you can help others
      by telling them about it. This source code may NOT be
      published or hosted without the author's consent.


      This code has been successfully compiled using the following compilers:
           Borland Delphi Client/Server Suite Version 3
}

program Server;

{ Needed to display output on the stdout (console) }
{$APPTYPE CONSOLE}

{ Uses Windows.pas and SysUtils.pas}
uses Windows, SysUtils;

    { Constant to define the max data size.                                     }
    const MAX_DATA_SIZE = 41;

    {### Variable Declarations ###}
    var


    { This is the format of the data we want to read:
            DATA:          password       port     exe name
            SIZE:            (20)         (6)        (15)
                     |------------------||----||-------------|                  }
                     
    { Initialise the array for the data to be read into (of size
      MAX_DATA_SIZE + 1 for a null char) .                                      }
      szReadData : Array[0..MAX_DATA_SIZE+1] of Char = '';

    { Temporary string.                                                         }
      szTmp : String;
    { Temporary Integer.                                                        }
      iTmp : Integer;

    { To record the number of bytes read later on.                              }
      iBytesRead : DWORD = 0;

    { File handle for the file to be opened, initialised to a invalid handle. }
      fhSource : THandle = INVALID_HANDLE_VALUE;



{ Entry point of the program. }
begin

    { Open the target file for writing to, using Win32 API. }
    fhSource := CreateFile(PChar(ParamStr(0)), // Address of file (Use Delphi's built-in function for this)
                           GENERIC_READ,       // Access attributes, ie allow reads.
                           FILE_SHARE_READ,    // Share Mode. Allow Read.
                           nil,                // Security Descriptor (nil means default)
                           OPEN_EXISTING,      // Creation Disposition (open existing file if exists)
                           0,                  // Flags and attributes (NONE)
                           0);                 // Template file (NONE)

    { The file has been opened successfully if the file handle is valid.        }
    if (fhSource <> INVALID_HANDLE_VALUE) then
    begin
        { Set the pointer to MAX_DATA_SIZE bytes from the end of the file.      }
        SetFilePointer(fhSource, -MAX_DATA_SIZE, nil, FILE_END);
       
        { Now read MAX_DATA_SIZE bytes from the end of the file. If the data
          was NOT successfully appended to the end of the server, then there
          will be an issue because you will read the program data, since there
          is no appended data to read. Therefore some kind of check to see if
          there is appended data is a good idea. I suggest some kind of key or
          identifier at the beginning or end of the data, which the presence of
          can be checked for once the data has been read.                       }
        ReadFile(fhSource, szReadData, MAX_DATA_SIZE, iBytesRead, nil);
       
        { Now finished with the file, so we must close it now.                  }
        CloseHandle(fhSource);
                
        { If the number of bytes read equals the number of bytes that we
           wanted to read, then the operation was successful.                   }
        if (iBytesRead = MAX_DATA_SIZE) then
         begin

           { Get the password from the read data... (trimming trailing spaces) }
           szTmp := Trim(Copy(szReadData, 1, 20));
           WriteLn('Password: ' + szTmp);

           { Get the port from the read data... }
           szTmp := Trim(Copy(szReadData, 21, 6));
           { Convert the input string into a number. To ensure a real number,
             default to 0 on failure.                                           }
           iTmp := StrToIntDef(szTmp, 0);
           WriteLn('Port: ' + IntToStr(iTmp));

           { Get the exe name from the read data... (trimming trailing spaces) }
           szTmp := Trim(Copy(szReadData, 27, 15));
           WriteLn('Exename: ' + szTmp);

           { Done!                                                              }
           MessageBox(0, 'File successfully read from!', 'Success!', MB_OK or MB_ICONINFORMATION);
           
         end
        else
           MessageBox(0, 'Error reading from the file!', 'Error!', MB_OK or MB_ICONERROR);
    end
    
    { Error opening the file, so report the error. Doing something such as 
       creating defaults or quitting quietly is probably a good idea in a real
       server. The message box is just to demonstrate that there may be errors 
       opening the file!                                                        }
    else
        { Nice little error message box!                                        }
        MessageBox(0, 'Error opening file!', 'Error!', MB_OK or MB_ICONERROR);

end.
