
 ;       Edit Server Example V1.02
 ;       (Server Part) in MASM by Faceless Wonder
 ;       
 ;       All source code hereforth is  Copyright 2002, 2003 Faceless Wonder
 ;       Email: YetAnotherFacelessWonder@yahoo.co.uk
 ;       Web:   http://areyoufearless.com/
 ; 
 ;       IMPORTANT NOTES:
 ;       The server source code contains NO hostile code of
 ;       any kind, or any Sockets implementation. This code
 ;       is just to demonstrate the mechanics of appending
 ;       and retrieving appended data to/from the end of a
 ;       executable.
 ; 
 ;       Some areas of the source code may appear bloated and
 ;       slightly cumbersome to some of the more experienced
 ;       programmers. The code has been written in such a way
 ;       that (hopefully) explains what the code is actually
 ;       doing. I'm well aware that it can easily be optimised
 ;       to reduce the working code size. I've sacrificed code
 ;       size for clarity and understandability.
 ; 
 ;       CONDITIONS OF USE:
 ;       If you use any of this source code either in full or
 ;       in part, then credit MUST be given to the author. If
 ;       you do not give due credit, then in simplest terms,
 ;       you are a lamer, and jepardise the future release of
 ;       other source codes.
 ; 
 ;       If you find his source code useful, you can help others
 ;       by telling them about it. This source code may NOT be
 ;       published or hosted without the author's consent.
 ; 
 ; 
 ;       This code has been successfully compiled using the following compilers:
 ;            Microsoft Assembler (MASM) 6.14.8


;#########################################################################

    .386
    .model          flat, stdcall
    option          casemap :none   

;#########################################################################

    include         \masm32\include\windows.inc
    include         \masm32\include\user32.inc
    include         \masm32\include\kernel32.inc
    include         \masm32\include\masm32.inc
   
    includelib      \masm32\lib\user32.lib
    includelib      \masm32\lib\kernel32.lib
    includelib      \masm32\lib\masm32.lib

;#########################################################################

    ; MASM MACRO allowing quoted text to be output to StdOut.
      print MACRO Quoted_Text:VARARG
        LOCAL Txt
          .data
            Txt db Quoted_Text,0
          .code
        invoke StdOut,ADDR Txt
      ENDM

;#########################################################################

    ; EQU is similar to C MACROs.
    MAX_PATH_SIZE EQU 1024                      ; Define the max path size.
    MAX_DATA_SIZE EQU 41                        ; Define the max data size

;#########################################################################
    
    .DATA 

        ; Buffer to store the filename of the currently running server file.
        ; Note that "n dup (c)" creates a buffer of n size, of character c.
        szFileName      db MAX_PATH_SIZE+1 dup (0)  

        ; This is the format of the data we want to read:
        ;   DATA:          password       port     exe name
        ;   SIZE:            (20)         (6)        (15)
        ;            |------------------||----||-------------|                  }
        
        ; Buffer to store the read data.
        szReadData      db MAX_DATA_SIZE+1 dup (0)

        ; Temporary buffer
        szTmpBuff       db MAX_DATA_SIZE+1 dup (0)

        ; Temporary position pointer
        iTmpPos         dd 0

        ; Read bytes counter
        iBytesRead      dd 0

        ; File Handle to manipulate the stub with
        fhSource        dd 0

    .DATA?
    
    .CONST

;#########################################################################

    .CODE

        ; Code Entry Point
        
        code_start:

                ; Get the running server file path.
                invoke GetModuleHandle, NULL     
                invoke GetModuleFileName, eax, ADDR szFileName, MAX_PATH_SIZE

                ; Open the target file for reading from, using Win32 API.
                ; Params in order:
                ;   Address of file.
                ;   Access attributes, ie allow reads.
                ;   Share Mode. Allow Read. 
                ;   Security Descriptor (NULL means default)   
                ;   Creation Disposition (open existing)
                ;   Flags and attributes (NONE)
                ;   Template file (NONE)
                invoke CreateFile, ADDR szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0
                mov fhSource, eax

                ; The file has been opened successfully if the file handle is valid.
                .IF (fhSource != INVALID_HANDLE_VALUE)

                    ; Set the pointer to MAX_DATA_SIZE bytes from the end of the file. 
                    invoke SetFilePointer, fhSource, -MAX_DATA_SIZE, NULL, FILE_END

                    ; Now read MAX_DATA_SIZE bytes from the end of the file. If the data 
                    ; was NOT successfully appended to the end of the server, then there 
                    ; will be an issue because you will read the program data, since there
                    ; is no appended data to read. Therefore some kind of check to see if
                    ; there is appended data is a good idea. I suggest some kind of key or
                    ; identifier at the beginning or end of the data, which the presence of
                    ; can be checked for once the data has been read.                     
                    invoke ReadFile, fhSource, ADDR szReadData, MAX_DATA_SIZE, ADDR iBytesRead, NULL

                    ; Now finished with the file, so we must close it now.
                    invoke CloseHandle, fhSource

                    ; If the number of bytes read equals the number of bytes that we
                    ; wanted to read, then the operation was successful.
                    .IF (iBytesRead == MAX_DATA_SIZE)

                        ; Get the password from the read data without trimming trailing spaces
                        xor eax, eax       ; clear eax, use for iteration.

                        ; GOT HERE

                    .ENDIF
                    

                .ENDIF

                ; Must call this when exit. This exits the program.
                invoke ExitProcess, 0
                        
        END code_start


;#########################################################################